package expr2.ExprAst;

import lpg.lpgjavaruntime.*;

/**
 *<em>
 *<li>Rule 4:  T ::= F
 *</em>
 *<p>
 *<b>
 *<li>Rule 3:  T ::= T * F
 *</b>
 */
public class T extends Ast implements IT
{
    private IT _T;
    private IF _F;

    public IT getT() { return _T; }
    public IF getF() { return _F; }

    public T(IToken leftIToken, IToken rightIToken,
             IT _T,
             IF _F)
    {
        super(leftIToken, rightIToken);

        this._T = _T;
        this._F = _F;
        initialize();
    }

    public boolean equals(Object o)
    {
        if (o == this) return true;
        //
        // The supers call is not required for now because Ast nodes
        // can only extend the root Ast, AstToken and AstList and none
        // of these nodes contain children.
        //
        // if (! super.equals(o)) return false;
        //
        if (! (o instanceof T)) return false;
        T other = (T) o;
        if (! _T.equals(other.getT())) return false;
        if (! _F.equals(other.getF())) return false;
        return true;
    }

    public int hashCode()
    {
        int hash = 7;
        hash = hash * 31 + (getT().hashCode());
        hash = hash * 31 + (getF().hashCode());
        return hash;
    }

    public void accept(Visitor v) { v.visit(this); }
    public void accept(ArgumentVisitor v, Object o) { v.visit(this, o); }
    public Object accept(ResultVisitor v) { return v.visit(this); }
    public Object accept(ResultArgumentVisitor v, Object o) { return v.visit(this, o); }
}


