//
// A copyright notice must contain a "C" enclosed in parentheses: (C) 
//

package expandedjavaparser.Ast;

import lpg.lpgjavaruntime.*;

/**
 *<b>
 *<li>Rule 5:  Literal ::= BooleanLiteral
 *</b>
 */
public class BooleanLiteral extends Ast implements ILiteral
{
    private IBooleanLiteral _BooleanLiteral;

    public IBooleanLiteral getBooleanLiteral() { return _BooleanLiteral; }

    public BooleanLiteral(IToken leftIToken, IToken rightIToken,
                          IBooleanLiteral _BooleanLiteral)
    {
        super(leftIToken, rightIToken);

        this._BooleanLiteral = _BooleanLiteral;
        initialize();
    }

    public boolean equals(Object o)
    {
        if (o == this) return true;
        //
        // The supers call is not required for now because Ast nodes
        // can only extend the root Ast, AstToken and AstList and none
        // of these nodes contain children.
        //
        // if (! super.equals(o)) return false;
        //
        if (! (o instanceof BooleanLiteral)) return false;
        BooleanLiteral other = (BooleanLiteral) o;
        if (! _BooleanLiteral.equals(other.getBooleanLiteral())) return false;
        return true;
    }

    public int hashCode()
    {
        int hash = 7;
        hash = hash * 31 + (getBooleanLiteral().hashCode());
        return hash;
    }

    public void accept(Visitor v) { v.visit(this); }
    public void accept(ArgumentVisitor v, Object o) { v.visit(this, o); }
    public Object accept(ResultVisitor v) { return v.visit(this); }
    public Object accept(ResultArgumentVisitor v, Object o) { return v.visit(this, o); }
}


