//
// A copyright notice must contain a "C" enclosed in parentheses: (C) 
//

package expandedjavaparser.Ast;

import lpg.lpgjavaruntime.*;

/**
 *<b>
 *<li>Rule 28:  ArrayType ::= Name Dims
 *</b>
 */
public class ClassOrInterfaceArrayType extends Ast implements IArrayType
{
    private IName _Name;
    private DimList _Dims;

    public IName getName() { return _Name; }
    public DimList getDims() { return _Dims; }

    public ClassOrInterfaceArrayType(IToken leftIToken, IToken rightIToken,
                                     IName _Name,
                                     DimList _Dims)
    {
        super(leftIToken, rightIToken);

        this._Name = _Name;
        this._Dims = _Dims;
        initialize();
    }

    public boolean equals(Object o)
    {
        if (o == this) return true;
        //
        // The supers call is not required for now because Ast nodes
        // can only extend the root Ast, AstToken and AstList and none
        // of these nodes contain children.
        //
        // if (! super.equals(o)) return false;
        //
        if (! (o instanceof ClassOrInterfaceArrayType)) return false;
        ClassOrInterfaceArrayType other = (ClassOrInterfaceArrayType) o;
        if (! _Name.equals(other.getName())) return false;
        if (! _Dims.equals(other.getDims())) return false;
        return true;
    }

    public int hashCode()
    {
        int hash = 7;
        hash = hash * 31 + (getName().hashCode());
        hash = hash * 31 + (getDims().hashCode());
        return hash;
    }

    public void accept(Visitor v) { v.visit(this); }
    public void accept(ArgumentVisitor v, Object o) { v.visit(this, o); }
    public Object accept(ResultVisitor v) { return v.visit(this); }
    public Object accept(ResultArgumentVisitor v, Object o) { return v.visit(this, o); }
}


