//
// A copyright notice must contain a "C" enclosed in parentheses: (C) 
//

package expandedjavaparser.Ast;

import lpg.lpgjavaruntime.*;

/**
 *<b>
 *<li>Rule 219:  DimExprs ::= DimExpr
 *<li>Rule 220:  DimExprs ::= DimExprs DimExpr
 *</b>
 */
public class DimExprList extends AstList implements IDimExprs
{
    public DimExpr getDimExprAt(int i) { return (DimExpr) getElementAt(i); }

    public DimExprList(IToken leftIToken, IToken rightIToken, boolean leftRecursive)
    {
        super(leftIToken, rightIToken, leftRecursive);
        initialize();
    }

    public DimExprList(DimExpr _DimExpr, boolean leftRecursive)
    {
        super((Ast) _DimExpr, leftRecursive);
        initialize();
    }

    public void add(DimExpr _DimExpr)
    {
        super.add((Ast) _DimExpr);
    }

    public boolean equals(Object o)
    {
        if (o == this) return true;
        if (! (o instanceof DimExprList)) return false;
        DimExprList other = (DimExprList) o;
        if (size() != other.size()) return false;
        for (int i = 0; i < size(); i++)
        {
            DimExpr element = getDimExprAt(i);
            if (! element.equals(other.getDimExprAt(i))) return false;
        }
        return true;
    }

    public int hashCode()
    {
        int hash = 7;
        for (int i = 0; i < size(); i++)
            hash = hash * 31 + (getDimExprAt(i).hashCode());
        return hash;
    }

    public void accept(Visitor v) { for (int i = 0; i < size(); i++) v.visit(getDimExprAt(i)); }
    public void accept(ArgumentVisitor v, Object o) { for (int i = 0; i < size(); i++) v.visit(getDimExprAt(i), o); }
    public Object accept(ResultVisitor v) { for (int i = 0; i < size(); i++) v.visit(getDimExprAt(i)); return null; }
    public Object accept(ResultArgumentVisitor v, Object o) { for (int i = 0; i < size(); i++) v.visit(getDimExprAt(i), o); return null; }
}


