//
// A copyright notice must contain a "C" enclosed in parentheses: (C) 
//

package expandedjavaparser.Ast;

import lpg.lpgjavaruntime.*;

/**
 *<b>
 *<li>Rule 92:  FormalParameter ::= Modifiersopt Type VariableDeclaratorId
 *</b>
 */
public class FormalParameter extends Ast implements IFormalParameter
{
    private ModifierList _Modifiersopt;
    private IType _Type;
    private VariableDeclaratorId _VariableDeclaratorId;

    public ModifierList getModifiersopt() { return _Modifiersopt; }
    public IType getType() { return _Type; }
    public VariableDeclaratorId getVariableDeclaratorId() { return _VariableDeclaratorId; }

    public FormalParameter(IToken leftIToken, IToken rightIToken,
                           ModifierList _Modifiersopt,
                           IType _Type,
                           VariableDeclaratorId _VariableDeclaratorId)
    {
        super(leftIToken, rightIToken);

        this._Modifiersopt = _Modifiersopt;
        this._Type = _Type;
        this._VariableDeclaratorId = _VariableDeclaratorId;
        initialize();
    }

    public boolean equals(Object o)
    {
        if (o == this) return true;
        //
        // The supers call is not required for now because Ast nodes
        // can only extend the root Ast, AstToken and AstList and none
        // of these nodes contain children.
        //
        // if (! super.equals(o)) return false;
        //
        if (! (o instanceof FormalParameter)) return false;
        FormalParameter other = (FormalParameter) o;
        if (! _Modifiersopt.equals(other.getModifiersopt())) return false;
        if (! _Type.equals(other.getType())) return false;
        if (! _VariableDeclaratorId.equals(other.getVariableDeclaratorId())) return false;
        return true;
    }

    public int hashCode()
    {
        int hash = 7;
        hash = hash * 31 + (getModifiersopt().hashCode());
        hash = hash * 31 + (getType().hashCode());
        hash = hash * 31 + (getVariableDeclaratorId().hashCode());
        return hash;
    }

    public void accept(Visitor v) { v.visit(this); }
    public void accept(ArgumentVisitor v, Object o) { v.visit(this, o); }
    public Object accept(ResultVisitor v) { return v.visit(this); }
    public Object accept(ResultArgumentVisitor v, Object o) { return v.visit(this, o); }
}


