//
// A copyright notice must contain a "C" enclosed in parentheses: (C) 
//

package expandedjavaparser.Ast;

import lpg.lpgjavaruntime.*;

/**
 *<b>
 *<li>Rule 36:  ImportDeclarations ::= ImportDeclaration
 *<li>Rule 37:  ImportDeclarations ::= ImportDeclarations ImportDeclaration
 *<li>Rule 314:  ImportDeclarationsopt ::= $Empty
 *<li>Rule 315:  ImportDeclarationsopt ::= ImportDeclarations
 *</b>
 */
public class ImportDeclarationList extends AstList implements IImportDeclarations, IImportDeclarationsopt
{
    public IImportDeclaration getImportDeclarationAt(int i) { return (IImportDeclaration) getElementAt(i); }

    public ImportDeclarationList(IToken leftIToken, IToken rightIToken, boolean leftRecursive)
    {
        super(leftIToken, rightIToken, leftRecursive);
        initialize();
    }

    public ImportDeclarationList(IImportDeclaration _ImportDeclaration, boolean leftRecursive)
    {
        super((Ast) _ImportDeclaration, leftRecursive);
        initialize();
    }

    public void add(IImportDeclaration _ImportDeclaration)
    {
        super.add((Ast) _ImportDeclaration);
    }

    public boolean equals(Object o)
    {
        if (o == this) return true;
        if (! (o instanceof ImportDeclarationList)) return false;
        ImportDeclarationList other = (ImportDeclarationList) o;
        if (size() != other.size()) return false;
        for (int i = 0; i < size(); i++)
        {
            IImportDeclaration element = getImportDeclarationAt(i);
            if (! element.equals(other.getImportDeclarationAt(i))) return false;
        }
        return true;
    }

    public int hashCode()
    {
        int hash = 7;
        for (int i = 0; i < size(); i++)
            hash = hash * 31 + (getImportDeclarationAt(i).hashCode());
        return hash;
    }

    public void accept(Visitor v) { for (int i = 0; i < size(); i++) getImportDeclarationAt(i).accept(v); }
    public void accept(ArgumentVisitor v, Object o) { for (int i = 0; i < size(); i++) getImportDeclarationAt(i).accept(v, o); }
    public Object accept(ResultVisitor v) { for (int i = 0; i < size(); i++) getImportDeclarationAt(i).accept(v); return null; }
    public Object accept(ResultArgumentVisitor v, Object o) { for (int i = 0; i < size(); i++) getImportDeclarationAt(i).accept(v, o); return null; }
}


