//
// A copyright notice must contain a "C" enclosed in parentheses: (C) 
//

package expandedjavaparser.Ast;

import lpg.lpgjavaruntime.*;

/**
 *<b>
 *<li>Rule 110:  InterfaceBody ::= { InterfaceMemberDeclarationsopt }
 *</b>
 */
public class InterfaceBody extends Ast implements IInterfaceBody
{
    private InterfaceMemberDeclarationList _InterfaceMemberDeclarationsopt;

    public InterfaceMemberDeclarationList getInterfaceMemberDeclarationsopt() { return _InterfaceMemberDeclarationsopt; }

    public InterfaceBody(IToken leftIToken, IToken rightIToken,
                         InterfaceMemberDeclarationList _InterfaceMemberDeclarationsopt)
    {
        super(leftIToken, rightIToken);

        this._InterfaceMemberDeclarationsopt = _InterfaceMemberDeclarationsopt;
        initialize();
    }

    public boolean equals(Object o)
    {
        if (o == this) return true;
        //
        // The supers call is not required for now because Ast nodes
        // can only extend the root Ast, AstToken and AstList and none
        // of these nodes contain children.
        //
        // if (! super.equals(o)) return false;
        //
        if (! (o instanceof InterfaceBody)) return false;
        InterfaceBody other = (InterfaceBody) o;
        if (! _InterfaceMemberDeclarationsopt.equals(other.getInterfaceMemberDeclarationsopt())) return false;
        return true;
    }

    public int hashCode()
    {
        int hash = 7;
        hash = hash * 31 + (getInterfaceMemberDeclarationsopt().hashCode());
        return hash;
    }

    public void accept(Visitor v) { v.visit(this); }
    public void accept(ArgumentVisitor v, Object o) { v.visit(this, o); }
    public Object accept(ResultVisitor v) { return v.visit(this); }
    public Object accept(ResultArgumentVisitor v, Object o) { return v.visit(this, o); }
}


