//
// A copyright notice must contain a "C" enclosed in parentheses: (C) 
//

package expandedjavaparser.Ast;

import lpg.lpgjavaruntime.*;

/**
 *<b>
 *<li>Rule 129:  LocalVariableDeclarationStatement ::= LocalVariableDeclaration ;
 *</b>
 */
public class LocalVariableDeclarationStatement extends Ast implements ILocalVariableDeclarationStatement
{
    private LocalVariableDeclaration _LocalVariableDeclaration;

    public LocalVariableDeclaration getLocalVariableDeclaration() { return _LocalVariableDeclaration; }

    public LocalVariableDeclarationStatement(IToken leftIToken, IToken rightIToken,
                                             LocalVariableDeclaration _LocalVariableDeclaration)
    {
        super(leftIToken, rightIToken);

        this._LocalVariableDeclaration = _LocalVariableDeclaration;
        initialize();
    }

    public boolean equals(Object o)
    {
        if (o == this) return true;
        //
        // The supers call is not required for now because Ast nodes
        // can only extend the root Ast, AstToken and AstList and none
        // of these nodes contain children.
        //
        // if (! super.equals(o)) return false;
        //
        if (! (o instanceof LocalVariableDeclarationStatement)) return false;
        LocalVariableDeclarationStatement other = (LocalVariableDeclarationStatement) o;
        if (! _LocalVariableDeclaration.equals(other.getLocalVariableDeclaration())) return false;
        return true;
    }

    public int hashCode()
    {
        int hash = 7;
        hash = hash * 31 + (getLocalVariableDeclaration().hashCode());
        return hash;
    }

    public void accept(Visitor v) { v.visit(this); }
    public void accept(ArgumentVisitor v, Object o) { v.visit(this, o); }
    public Object accept(ResultVisitor v) { return v.visit(this); }
    public Object accept(ResultArgumentVisitor v, Object o) { return v.visit(this, o); }
}


