//
// A copyright notice must contain a "C" enclosed in parentheses: (C) 
//

package expandedjavaparser.Ast;

import lpg.lpgjavaruntime.*;

/**
 *<b>
 *<li>Rule 257:  MultiplicativeExpression ::= MultiplicativeExpression % UnaryExpression
 *</b>
 */
public class ModExpression extends Ast implements IMultiplicativeExpression
{
    private IMultiplicativeExpression _MultiplicativeExpression;
    private IUnaryExpression _UnaryExpression;

    public IMultiplicativeExpression getMultiplicativeExpression() { return _MultiplicativeExpression; }
    public IUnaryExpression getUnaryExpression() { return _UnaryExpression; }

    public ModExpression(IToken leftIToken, IToken rightIToken,
                         IMultiplicativeExpression _MultiplicativeExpression,
                         IUnaryExpression _UnaryExpression)
    {
        super(leftIToken, rightIToken);

        this._MultiplicativeExpression = _MultiplicativeExpression;
        this._UnaryExpression = _UnaryExpression;
        initialize();
    }

    public boolean equals(Object o)
    {
        if (o == this) return true;
        //
        // The supers call is not required for now because Ast nodes
        // can only extend the root Ast, AstToken and AstList and none
        // of these nodes contain children.
        //
        // if (! super.equals(o)) return false;
        //
        if (! (o instanceof ModExpression)) return false;
        ModExpression other = (ModExpression) o;
        if (! _MultiplicativeExpression.equals(other.getMultiplicativeExpression())) return false;
        if (! _UnaryExpression.equals(other.getUnaryExpression())) return false;
        return true;
    }

    public int hashCode()
    {
        int hash = 7;
        hash = hash * 31 + (getMultiplicativeExpression().hashCode());
        hash = hash * 31 + (getUnaryExpression().hashCode());
        return hash;
    }

    public void accept(Visitor v) { v.visit(this); }
    public void accept(ArgumentVisitor v, Object o) { v.visit(this, o); }
    public Object accept(ResultVisitor v) { return v.visit(this); }
    public Object accept(ResultArgumentVisitor v, Object o) { return v.visit(this, o); }
}


