//
// A copyright notice must contain a "C" enclosed in parentheses: (C) 
//

package expandedjavaparser.Ast;

import lpg.lpgjavaruntime.*;

/**
 *<b>
 *<li>Rule 206:  PrimaryNoNewArray ::= ( Expression )
 *</b>
 */
public class ParenthesizedExpression extends Ast implements IPrimaryNoNewArray
{
    private IExpression _Expression;

    public IExpression getExpression() { return _Expression; }

    public ParenthesizedExpression(IToken leftIToken, IToken rightIToken,
                                   IExpression _Expression)
    {
        super(leftIToken, rightIToken);

        this._Expression = _Expression;
        initialize();
    }

    public boolean equals(Object o)
    {
        if (o == this) return true;
        //
        // The supers call is not required for now because Ast nodes
        // can only extend the root Ast, AstToken and AstList and none
        // of these nodes contain children.
        //
        // if (! super.equals(o)) return false;
        //
        if (! (o instanceof ParenthesizedExpression)) return false;
        ParenthesizedExpression other = (ParenthesizedExpression) o;
        if (! _Expression.equals(other.getExpression())) return false;
        return true;
    }

    public int hashCode()
    {
        int hash = 7;
        hash = hash * 31 + (getExpression().hashCode());
        return hash;
    }

    public void accept(Visitor v) { v.visit(this); }
    public void accept(ArgumentVisitor v, Object o) { v.visit(this, o); }
    public Object accept(ResultVisitor v) { return v.visit(this); }
    public Object accept(ResultArgumentVisitor v, Object o) { return v.visit(this, o); }
}


