//
// A copyright notice must contain a "C" enclosed in parentheses: (C) 
//

package expandedjavaparser.Ast;

import lpg.lpgjavaruntime.*;

/**
 *<b>
 *<li>Rule 238:  PostIncrementExpression ::= PostfixExpression ++
 *</b>
 */
public class PostIncrementExpression extends Ast implements IPostIncrementExpression
{
    private IPostfixExpression _PostfixExpression;

    public IPostfixExpression getPostfixExpression() { return _PostfixExpression; }

    public PostIncrementExpression(IToken leftIToken, IToken rightIToken,
                                   IPostfixExpression _PostfixExpression)
    {
        super(leftIToken, rightIToken);

        this._PostfixExpression = _PostfixExpression;
        initialize();
    }

    public boolean equals(Object o)
    {
        if (o == this) return true;
        //
        // The supers call is not required for now because Ast nodes
        // can only extend the root Ast, AstToken and AstList and none
        // of these nodes contain children.
        //
        // if (! super.equals(o)) return false;
        //
        if (! (o instanceof PostIncrementExpression)) return false;
        PostIncrementExpression other = (PostIncrementExpression) o;
        if (! _PostfixExpression.equals(other.getPostfixExpression())) return false;
        return true;
    }

    public int hashCode()
    {
        int hash = 7;
        hash = hash * 31 + (getPostfixExpression().hashCode());
        return hash;
    }

    public void accept(Visitor v) { v.visit(this); }
    public void accept(ArgumentVisitor v, Object o) { v.visit(this, o); }
    public Object accept(ResultVisitor v) { return v.visit(this); }
    public Object accept(ResultArgumentVisitor v, Object o) { return v.visit(this, o); }
}


