//
// A copyright notice must contain a "C" enclosed in parentheses: (C) 
//

package expandedjavaparser.Ast;

import lpg.lpgjavaruntime.*;

/**
 *<b>
 *<li>Rule 229:  MethodInvocation ::= Primary . IDENTIFIER ( ArgumentListopt )
 *</b>
 */
public class PrimaryMethodInvocation extends Ast implements IMethodInvocation
{
    private IPrimary _Primary;
    private ExpressionList _ArgumentListopt;

    public IPrimary getPrimary() { return _Primary; }
    public ExpressionList getArgumentListopt() { return _ArgumentListopt; }

    public PrimaryMethodInvocation(IToken leftIToken, IToken rightIToken,
                                   IPrimary _Primary,
                                   ExpressionList _ArgumentListopt)
    {
        super(leftIToken, rightIToken);

        this._Primary = _Primary;
        this._ArgumentListopt = _ArgumentListopt;
        initialize();
    }

    public boolean equals(Object o)
    {
        if (o == this) return true;
        //
        // The supers call is not required for now because Ast nodes
        // can only extend the root Ast, AstToken and AstList and none
        // of these nodes contain children.
        //
        // if (! super.equals(o)) return false;
        //
        if (! (o instanceof PrimaryMethodInvocation)) return false;
        PrimaryMethodInvocation other = (PrimaryMethodInvocation) o;
        if (! _Primary.equals(other.getPrimary())) return false;
        if (! _ArgumentListopt.equals(other.getArgumentListopt())) return false;
        return true;
    }

    public int hashCode()
    {
        int hash = 7;
        hash = hash * 31 + (getPrimary().hashCode());
        hash = hash * 31 + (getArgumentListopt().hashCode());
        return hash;
    }

    public void accept(Visitor v) { v.visit(this); }
    public void accept(ArgumentVisitor v, Object o) { v.visit(this, o); }
    public Object accept(ResultVisitor v) { return v.visit(this); }
    public Object accept(ResultArgumentVisitor v, Object o) { return v.visit(this, o); }
}


