//
// A copyright notice must contain a "C" enclosed in parentheses: (C) 
//

package expandedjavaparser.Ast;

import lpg.lpgjavaruntime.*;

/**
 *<b>
 *<li>Rule 34:  QualifiedName ::= Name . IDENTIFIER
 *</b>
 */
public class QualifiedName extends Ast implements IQualifiedName
{
    private IName _Name;

    public IName getName() { return _Name; }

    public QualifiedName(IToken leftIToken, IToken rightIToken,
                         IName _Name)
    {
        super(leftIToken, rightIToken);

        this._Name = _Name;
        initialize();
    }

    public boolean equals(Object o)
    {
        if (o == this) return true;
        //
        // The supers call is not required for now because Ast nodes
        // can only extend the root Ast, AstToken and AstList and none
        // of these nodes contain children.
        //
        // if (! super.equals(o)) return false;
        //
        if (! (o instanceof QualifiedName)) return false;
        QualifiedName other = (QualifiedName) o;
        if (! _Name.equals(other.getName())) return false;
        return true;
    }

    public int hashCode()
    {
        int hash = 7;
        hash = hash * 31 + (getName().hashCode());
        return hash;
    }

    public void accept(Visitor v) { v.visit(this); }
    public void accept(ArgumentVisitor v, Object o) { v.visit(this, o); }
    public Object accept(ResultVisitor v) { return v.visit(this); }
    public Object accept(ResultArgumentVisitor v, Object o) { return v.visit(this, o); }
}


