//
// A copyright notice must contain a "C" enclosed in parentheses: (C) 
//

package expandedjavaparser.Ast;

public interface ResultArgumentVisitor
{
    Object visit(AstToken n, Object o);
    Object visit(IntegerLiteral n, Object o);
    Object visit(LongLiteral n, Object o);
    Object visit(FloatLiteral n, Object o);
    Object visit(DoubleLiteral n, Object o);
    Object visit(BooleanLiteral n, Object o);
    Object visit(CharacterLiteral n, Object o);
    Object visit(StringLiteral n, Object o);
    Object visit(NullLiteral n, Object o);
    Object visit(TrueLiteral n, Object o);
    Object visit(FalseLiteral n, Object o);
    Object visit(BooleanType n, Object o);
    Object visit(ByteType n, Object o);
    Object visit(ShortType n, Object o);
    Object visit(IntType n, Object o);
    Object visit(LongType n, Object o);
    Object visit(CharType n, Object o);
    Object visit(FloatType n, Object o);
    Object visit(DoubleType n, Object o);
    Object visit(PrimitiveArrayType n, Object o);
    Object visit(ClassOrInterfaceArrayType n, Object o);
    Object visit(SimpleName n, Object o);
    Object visit(QualifiedName n, Object o);
    Object visit(CompilationUnit n, Object o);
    Object visit(ImportDeclarationList n, Object o);
    Object visit(TypeDeclarationList n, Object o);
    Object visit(PackageDeclaration n, Object o);
    Object visit(SingleTypeImportDeclaration n, Object o);
    Object visit(TypeImportOnDemandDeclaration n, Object o);
    Object visit(EmptyDeclaration n, Object o);
    Object visit(ModifierList n, Object o);
    Object visit(PublicModifier n, Object o);
    Object visit(ProtectedModifier n, Object o);
    Object visit(PrivateModifier n, Object o);
    Object visit(StaticModifier n, Object o);
    Object visit(AbstractModifier n, Object o);
    Object visit(FinalModifier n, Object o);
    Object visit(NativeModifier n, Object o);
    Object visit(StrictfpModifier n, Object o);
    Object visit(SynchronizedModifier n, Object o);
    Object visit(TransientModifier n, Object o);
    Object visit(VolatileModifier n, Object o);
    Object visit(ClassDeclaration n, Object o);
    Object visit(Super n, Object o);
    Object visit(InterfaceTypeList n, Object o);
    Object visit(ClassBody n, Object o);
    Object visit(ClassBodyDeclarationList n, Object o);
    Object visit(FieldDeclaration n, Object o);
    Object visit(VariableDeclaratorList n, Object o);
    Object visit(VariableDeclarator n, Object o);
    Object visit(VariableDeclaratorId n, Object o);
    Object visit(MethodDeclaration n, Object o);
    Object visit(TypedMethodHeader n, Object o);
    Object visit(VoidMethodHeader n, Object o);
    Object visit(MethodDeclarator n, Object o);
    Object visit(FormalParameterList n, Object o);
    Object visit(FormalParameter n, Object o);
    Object visit(ClassTypeList n, Object o);
    Object visit(EmptyMethodBody n, Object o);
    Object visit(StaticInitializer n, Object o);
    Object visit(ConstructorDeclaration n, Object o);
    Object visit(ConstructorDeclarator n, Object o);
    Object visit(ConstructorBody n, Object o);
    Object visit(ThisCall n, Object o);
    Object visit(SuperCall n, Object o);
    Object visit(InterfaceDeclaration n, Object o);
    Object visit(InterfaceBody n, Object o);
    Object visit(InterfaceMemberDeclarationList n, Object o);
    Object visit(AbstractMethodDeclaration n, Object o);
    Object visit(ArrayInitializer n, Object o);
    Object visit(VariableInitializerList n, Object o);
    Object visit(Block n, Object o);
    Object visit(BlockStatementList n, Object o);
    Object visit(LocalVariableDeclarationStatement n, Object o);
    Object visit(LocalVariableDeclaration n, Object o);
    Object visit(EmptyStatement n, Object o);
    Object visit(LabeledStatement n, Object o);
    Object visit(ExpressionStatement n, Object o);
    Object visit(IfStatement n, Object o);
    Object visit(SwitchStatement n, Object o);
    Object visit(SwitchBlock n, Object o);
    Object visit(SwitchBlockStatementList n, Object o);
    Object visit(SwitchBlockStatement n, Object o);
    Object visit(SwitchLabelList n, Object o);
    Object visit(CaseLabel n, Object o);
    Object visit(DefaultLabel n, Object o);
    Object visit(WhileStatement n, Object o);
    Object visit(DoStatement n, Object o);
    Object visit(ForStatement n, Object o);
    Object visit(StatementExpressionList n, Object o);
    Object visit(BreakStatement n, Object o);
    Object visit(ContinueStatement n, Object o);
    Object visit(ReturnStatement n, Object o);
    Object visit(ThrowStatement n, Object o);
    Object visit(SynchronizedStatement n, Object o);
    Object visit(TryStatement n, Object o);
    Object visit(CatchClauseList n, Object o);
    Object visit(CatchClause n, Object o);
    Object visit(Finally n, Object o);
    Object visit(ParenthesizedExpression n, Object o);
    Object visit(PrimaryThis n, Object o);
    Object visit(PrimaryClassLiteral n, Object o);
    Object visit(PrimaryVoidClassLiteral n, Object o);
    Object visit(ClassInstanceCreationExpression n, Object o);
    Object visit(ExpressionList n, Object o);
    Object visit(ArrayCreationExpression n, Object o);
    Object visit(DimExprList n, Object o);
    Object visit(DimExpr n, Object o);
    Object visit(DimList n, Object o);
    Object visit(Dim n, Object o);
    Object visit(FieldAccess n, Object o);
    Object visit(SuperFieldAccess n, Object o);
    Object visit(MethodInvocation n, Object o);
    Object visit(PrimaryMethodInvocation n, Object o);
    Object visit(SuperMethodInvocation n, Object o);
    Object visit(ArrayAccess n, Object o);
    Object visit(PostIncrementExpression n, Object o);
    Object visit(PostDecrementExpression n, Object o);
    Object visit(PlusUnaryExpression n, Object o);
    Object visit(MinusUnaryExpression n, Object o);
    Object visit(PreIncrementExpression n, Object o);
    Object visit(PreDecrementExpression n, Object o);
    Object visit(UnaryComplementExpression n, Object o);
    Object visit(UnaryNotExpression n, Object o);
    Object visit(PrimitiveCastExpression n, Object o);
    Object visit(ClassCastExpression n, Object o);
    Object visit(MultiplyExpression n, Object o);
    Object visit(DivideExpression n, Object o);
    Object visit(ModExpression n, Object o);
    Object visit(AddExpression n, Object o);
    Object visit(SubtractExpression n, Object o);
    Object visit(LeftShiftExpression n, Object o);
    Object visit(RightShiftExpression n, Object o);
    Object visit(UnsignedRightShiftExpression n, Object o);
    Object visit(LessExpression n, Object o);
    Object visit(GreaterExpression n, Object o);
    Object visit(LessEqualExpression n, Object o);
    Object visit(GreaterEqualExpression n, Object o);
    Object visit(InstanceofExpression n, Object o);
    Object visit(EqualExpression n, Object o);
    Object visit(NotEqualExpression n, Object o);
    Object visit(AndExpression n, Object o);
    Object visit(ExclusiveOrExpression n, Object o);
    Object visit(InclusiveOrExpression n, Object o);
    Object visit(ConditionalAndExpression n, Object o);
    Object visit(ConditionalOrExpression n, Object o);
    Object visit(ConditionalExpression n, Object o);
    Object visit(Assignment n, Object o);
    Object visit(EqualOperator n, Object o);
    Object visit(MultiplyEqualOperator n, Object o);
    Object visit(DivideEqualOperator n, Object o);
    Object visit(ModEqualOperator n, Object o);
    Object visit(PlusEqualOperator n, Object o);
    Object visit(MinusEqualOperator n, Object o);
    Object visit(LeftShiftEqualOperator n, Object o);
    Object visit(RightShiftEqualOperator n, Object o);
    Object visit(UnsignedRightShiftEqualOperator n, Object o);
    Object visit(AndEqualOperator n, Object o);
    Object visit(ExclusiveOrEqualOperator n, Object o);
    Object visit(OrEqualOperator n, Object o);
    Object visit(Commaopt n, Object o);
    Object visit(IDENTIFIERopt n, Object o);
}

