//
// A copyright notice must contain a "C" enclosed in parentheses: (C) 
//

package expandedjavaparser.Ast;

import lpg.lpgjavaruntime.*;

/**
 *<b>
 *<li>Rule 98:  StaticInitializer ::= static Block
 *</b>
 */
public class StaticInitializer extends Ast implements IStaticInitializer
{
    private Block _Block;

    public Block getBlock() { return _Block; }

    public StaticInitializer(IToken leftIToken, IToken rightIToken,
                             Block _Block)
    {
        super(leftIToken, rightIToken);

        this._Block = _Block;
        initialize();
    }

    public boolean equals(Object o)
    {
        if (o == this) return true;
        //
        // The supers call is not required for now because Ast nodes
        // can only extend the root Ast, AstToken and AstList and none
        // of these nodes contain children.
        //
        // if (! super.equals(o)) return false;
        //
        if (! (o instanceof StaticInitializer)) return false;
        StaticInitializer other = (StaticInitializer) o;
        if (! _Block.equals(other.getBlock())) return false;
        return true;
    }

    public int hashCode()
    {
        int hash = 7;
        hash = hash * 31 + (getBlock().hashCode());
        return hash;
    }

    public void accept(Visitor v) { v.visit(this); }
    public void accept(ArgumentVisitor v, Object o) { v.visit(this, o); }
    public Object accept(ResultVisitor v) { return v.visit(this); }
    public Object accept(ResultArgumentVisitor v, Object o) { return v.visit(this, o); }
}


