//
// A copyright notice must contain a "C" enclosed in parentheses: (C) 
//

package expandedjavaparser.Ast;

import lpg.lpgjavaruntime.*;

/**
 *<b>
 *<li>Rule 62:  Super ::= extends ClassType
 *</b>
 */
public class Super extends Ast implements ISuper
{
    private IClassType _ClassType;

    public IClassType getClassType() { return _ClassType; }

    public Super(IToken leftIToken, IToken rightIToken,
                 IClassType _ClassType)
    {
        super(leftIToken, rightIToken);

        this._ClassType = _ClassType;
        initialize();
    }

    public boolean equals(Object o)
    {
        if (o == this) return true;
        //
        // The supers call is not required for now because Ast nodes
        // can only extend the root Ast, AstToken and AstList and none
        // of these nodes contain children.
        //
        // if (! super.equals(o)) return false;
        //
        if (! (o instanceof Super)) return false;
        Super other = (Super) o;
        if (! _ClassType.equals(other.getClassType())) return false;
        return true;
    }

    public int hashCode()
    {
        int hash = 7;
        hash = hash * 31 + (getClassType().hashCode());
        return hash;
    }

    public void accept(Visitor v) { v.visit(this); }
    public void accept(ArgumentVisitor v, Object o) { v.visit(this, o); }
    public Object accept(ResultVisitor v) { return v.visit(this); }
    public Object accept(ResultArgumentVisitor v, Object o) { return v.visit(this, o); }
}


