//
// A copyright notice must contain a "C" enclosed in parentheses: (C) 
//

package expandedjavaparser.Ast;

import expandedjavaparser.*;
import lpg.lpgjavaruntime.*;

/**
 *<b>
 *<li>Rule 169:  SwitchBlock ::= { SwitchLabelsopt }
 *<li>Rule 170:  SwitchBlock ::= { SwitchBlockStatements SwitchLabelsopt }
 *</b>
 */
public class SwitchBlock extends Ast implements ISwitchBlock
{
    private JavaParser environment;
    public JavaParser getEnvironment() { return environment; }

    private SwitchLabelList _SwitchLabelsopt;
    private SwitchBlockStatementList _SwitchBlockStatements;

    public SwitchLabelList getSwitchLabelsopt() { return _SwitchLabelsopt; }
    /**
     * The value returned by <b>getSwitchBlockStatements</b> may be <b>null</b>
     */
    public SwitchBlockStatementList getSwitchBlockStatements() { return _SwitchBlockStatements; }

    public SwitchBlock(JavaParser environment, IToken leftIToken, IToken rightIToken,
                       SwitchLabelList _SwitchLabelsopt,
                       SwitchBlockStatementList _SwitchBlockStatements)
    {
        super(leftIToken, rightIToken);

        this.environment = environment;
        this._SwitchLabelsopt = _SwitchLabelsopt;
        this._SwitchBlockStatements = _SwitchBlockStatements;
        initialize();
    }

    public boolean equals(Object o)
    {
        if (o == this) return true;
        //
        // The supers call is not required for now because Ast nodes
        // can only extend the root Ast, AstToken and AstList and none
        // of these nodes contain children.
        //
        // if (! super.equals(o)) return false;
        //
        if (! (o instanceof SwitchBlock)) return false;
        SwitchBlock other = (SwitchBlock) o;
        if (! _SwitchLabelsopt.equals(other.getSwitchLabelsopt())) return false;
        if (_SwitchBlockStatements == null && other.getSwitchBlockStatements() != null) return false;
        else if (! _SwitchBlockStatements.equals(other.getSwitchBlockStatements())) return false;
        return true;
    }

    public int hashCode()
    {
        int hash = 7;
        hash = hash * 31 + (getSwitchLabelsopt().hashCode());
        hash = hash * 31 + (getSwitchBlockStatements() == null ? 0 : getSwitchBlockStatements().hashCode());
        return hash;
    }

    public void accept(Visitor v) { v.visit(this); }
    public void accept(ArgumentVisitor v, Object o) { v.visit(this, o); }
    public Object accept(ResultVisitor v) { return v.visit(this); }
    public Object accept(ResultArgumentVisitor v, Object o) { return v.visit(this, o); }

        public void initialize()
        {
            if (_SwitchBlockStatements == null)
            {
                IToken left = environment.getLeftIToken(),
                       right = environment.getPrevious(left);
                _SwitchBlockStatements = new SwitchBlockStatementList(left, right, true);
            }
        }
}


