//
// A copyright notice must contain a "C" enclosed in parentheses: (C) 
//

package expandedjavaparser.Ast;

import lpg.lpgjavaruntime.*;

/**
 *<b>
 *<li>Rule 173:  SwitchBlockStatement ::= SwitchLabels BlockStatements
 *</b>
 */
public class SwitchBlockStatement extends Ast implements ISwitchBlockStatement
{
    private SwitchLabelList _SwitchLabels;
    private BlockStatementList _BlockStatements;

    public SwitchLabelList getSwitchLabels() { return _SwitchLabels; }
    public BlockStatementList getBlockStatements() { return _BlockStatements; }

    public SwitchBlockStatement(IToken leftIToken, IToken rightIToken,
                                SwitchLabelList _SwitchLabels,
                                BlockStatementList _BlockStatements)
    {
        super(leftIToken, rightIToken);

        this._SwitchLabels = _SwitchLabels;
        this._BlockStatements = _BlockStatements;
        initialize();
    }

    public boolean equals(Object o)
    {
        if (o == this) return true;
        //
        // The supers call is not required for now because Ast nodes
        // can only extend the root Ast, AstToken and AstList and none
        // of these nodes contain children.
        //
        // if (! super.equals(o)) return false;
        //
        if (! (o instanceof SwitchBlockStatement)) return false;
        SwitchBlockStatement other = (SwitchBlockStatement) o;
        if (! _SwitchLabels.equals(other.getSwitchLabels())) return false;
        if (! _BlockStatements.equals(other.getBlockStatements())) return false;
        return true;
    }

    public int hashCode()
    {
        int hash = 7;
        hash = hash * 31 + (getSwitchLabels().hashCode());
        hash = hash * 31 + (getBlockStatements().hashCode());
        return hash;
    }

    public void accept(Visitor v) { v.visit(this); }
    public void accept(ArgumentVisitor v, Object o) { v.visit(this, o); }
    public Object accept(ResultVisitor v) { return v.visit(this); }
    public Object accept(ResultArgumentVisitor v, Object o) { return v.visit(this, o); }
}


