--
-- An LPG Parser Template Using lpg.jar
--
--
-- B E G I N N I N G   O F   T E M P L A T E   btParserTemplateC
--
-- In a parser using this template, the following macros may be redefined:
--
--     $import_classes
--     $action_class
--     $additional_interfaces
--     $ast_class
--
%Options programming_language=java,margin=8,backtrack
%Options table,error_maps,scopes
%options action=("*.java", "/.", "./")
%options headers=("*.java", "/:", ":/")
%options ParseTable=lpg.lpgjavaruntime.ParseTable

$Notice /.$copyright./

$Define
        $copyright /../

        $DefaultAllocation
        /:
                ruleAction[$rule_number] = new act$rule_number$();:/

        $NoAllocation
        /:
                ruleAction[$rule_number] = new NoAction();:/

        $NullAllocation
        /:
                ruleAction[$rule_number] = new NullAction();:/

        $Header
        /.
            //
            // Rule $rule_number:  $rule_text
            //./

        $DefaultAction
        /.$DefaultAllocation $Header
            final class act$rule_number extends Action./

        --
        -- This macro is used to initialize the ruleAction array
        -- to the null_action function.
        --
        $NullAction
        /. $NullAllocation $Header
            //
            // final class NullAction extends Action
            //
        ./

        --
        -- This macro is used to initialize the ruleAction array
        -- to the no_action function.
        --
        $NoAction
        /. $NoAllocation $Header
            //
            // final class NullAction extends Action
            //
        ./

        --
        -- This is the header for a ruleAction class
        --
        $BeginAction
        /.$DefaultAllocation $Header
            final class act$rule_number extends Action
            {
                public void action()
                {./

        $EndAction
        /.          return;
                }
            }./

        $BeginJava
        /.$BeginAction
                    $symbol_declarations./

        $EndJava /.$EndAction./

        $SplitActions /../

        --
        -- Macros that may be needed in a parser using this template
        --
        $import_classes /../
        $action_class /.$action_type./
        $additional_interfaces /../
        $ast_class /.$ast_type./
        $setSym1 /.getParser().setSym1./
        $setResult /.getParser().setSym1./
        $getSym /.getParser().getSym./
        $getToken /.getParser().getToken./
        $getIToken /.getIToken./
        $getLeftSpan /.getParser().getFirstToken./
        $getRightSpan /.getParser().getLastToken./
$End

$Headers
    /.
        $copyright
        $import_classes
        import lpg.lpgjavaruntime.*;

        public class $action_class extends PrsStream implements RuleAction$additional_interfaces
        {
            private static ParseTable prs = new $prs_type();
            private BacktrackingParser btParser;

            public BacktrackingParser getParser() { return btParser; }
            private void setResult(Object object) { btParser.setSym1(object); }
            public Object getRhsSym(int i) { return btParser.getSym(i); }

            public int getRhsTokenIndex(int i) { return btParser.getToken(i); }
            public IToken getRhsIToken(int i) { return super.getIToken(getRhsTokenIndex(i)); }
        
            public int getRhsFirstTokenIndex(int i) { return btParser.getFirstToken(i); }
            public IToken getRhsFirstIToken(int i) { return super.getIToken(getRhsFirstTokenIndex(i)); }

            public int getRhsLastTokenIndex(int i) { return btParser.getLastToken(i); }
            public IToken getRhsLastIToken(int i) { return super.getIToken(getRhsLastTokenIndex(i)); }

            public int getLeftSpan() { return btParser.getFirstToken(); }
            public IToken getLeftIToken()  { return super.getIToken(getLeftSpan()); }

            public int getRightSpan() { return btParser.getLastToken(); }
            public IToken getRightIToken() { return super.getIToken(getRightSpan()); }

            public int getRhsErrorTokenIndex(int i)
            {
                int index = btParser.getToken(i);
                IToken err = super.getIToken(index);
                return (err instanceof ErrorToken ? index : 0);
            }
            public ErrorToken getRhsErrorIToken(int i)
            {
                int index = btParser.getToken(i);
                IToken err = super.getIToken(index);
                return (ErrorToken) (err instanceof ErrorToken ? err : null);
            }

            public $action_class(LexStream lexStream)
            {
                super(lexStream);

                try
                {
                    super.remapTerminalSymbols(orderedTerminalSymbols(), $prs_type.EOFT_SYMBOL);
                }
                catch(NullExportedSymbolsException e) {
                }
                catch(NullTerminalSymbolsException e) {
                }
                catch(UnimplementedTerminalsException e)
                {
                    java.util.ArrayList unimplemented_symbols = e.getSymbols();
                    System.out.println("The Lexer will not scan the following token(s):");
                    for (int i = 0; i < unimplemented_symbols.size(); i++)
                    {
                        Integer id = (Integer) unimplemented_symbols.get(i);
                        System.out.println("    " + $sym_type.orderedTerminalSymbols[id.intValue()]);               
                    }
                    System.out.println();                        
                }
                catch(UndefinedEofSymbolException e)
                {
                    System.out.println("The Lexer does not implement the Eof symbol " +
                                       $sym_type.orderedTerminalSymbols[$prs_type.EOFT_SYMBOL]);
                    System.exit(12);
                } 
            }

            public String[] orderedTerminalSymbols() { return $sym_type.orderedTerminalSymbols; }
            public String getTokenKindName(int kind) { return $sym_type.orderedTerminalSymbols[kind]; }
            public int getEOFTokenKind() { return $prs_type.EOFT_SYMBOL; }
            public PrsStream getParseStream() { return (PrsStream) this; }
    
            //
            // Report error message for given error_token.
            //
            public final void reportErrorTokenMessage(int error_token, String msg)
            {
                int firsttok = super.getFirstErrorToken(error_token),
                    lasttok = super.getLastErrorToken(error_token);
                String location = super.getFileName() + ':' +
                                  (firsttok > lasttok
                                            ? (super.getEndLine(lasttok) + ":" + super.getEndColumn(lasttok))
                                            : (super.getLine(error_token) + ":" +
                                               super.getColumn(error_token) + ":" +
                                               super.getEndLine(error_token) + ":" +
                                               super.getEndColumn(error_token)))
                                  + ": ";
                super.reportError((firsttok > lasttok ? ParseErrorCodes.INSERTION_CODE : ParseErrorCodes.SUBSTITUTION_CODE), location, msg);
            }

            public $ast_class parser()
            {
                return parser(null, 0);
            }
            
            public $ast_class parser(Monitor monitor)
            {
                return parser(monitor, 0);
            }
            
            public $ast_class parser(int error_repair_count)
            {
                return parser(null, error_repair_count);
            }
            
            public $ast_class parser(Monitor monitor, int error_repair_count)
            {
                try
                {
                    btParser = new BacktrackingParser((TokenStream) this, prs, (RuleAction) this);
                }
                catch (NotBacktrackParseTableException e)
                {
                    System.out.println("****Error: Regenerate $prs_type.java with -BACKTRACK option");
                    System.exit(1);
                }
                catch (BadParseSymFileException e)
                {
                    System.out.println("****Error: Bad Parser Symbol File -- $sym_type.java. Regenerate $prs_type.java");
                    System.exit(1);
                }

                try
                {
                    return ($ast_class) btParser.parse(error_repair_count);
                }
                catch (BadParseException e)
                {
                    reset(e.error_token); // point to error token

                    DiagnoseParser diagnoseParser = new DiagnoseParser((TokenStream) this, prs);
                    diagnoseParser.diagnose(e.error_token);
                }

                return null;
            }

            public final void ruleAction(int rule_number)
            {
                ruleAction[rule_number].action();
            }

            abstract class Action
            {
                public abstract void action();
            }

            final class NoAction extends Action
            {
                public void action() {}
            }

            //
            // Action for a null rule
            //
            final class NullAction extends Action
            {
                public void action() { btParser.setSym1(null); }
            }
    ./

    /:

            //
            // Declare and initialize ruleAction array.
            //
            Action ruleAction[] = new Action[$NUM_RULES + 1];
            {
                ruleAction[0] = null;
    :/
$End

$Trailers
    /.
        }
    ./

    /:


                //
                // Make sure that all elements of ruleAction are properly initialized
                //
                for (int i = 0; i < ruleAction.length; i++)
                {
                    if (ruleAction[i] == null)
                         ruleAction[i] = new NoAction();
                }
            };
    :/
$End
--
-- E N D   O F   T E M P L A T E
--
