// XMOS
package org.eclipse.cdt.debug.internal.core.model;

// Chanend connection
public class XCoreThreadConnection{
	public final static int STATUS_NON_ACTIVE = 0;
	public final static int STATUS_STREAMING = 1;
	private int direction;
	private Object connectedObject;
	private int connectionStatus;
	public String resourceID;	// unique ID 
	public String dest;		// dest ID
	private int channum;
	private CThread owner;
	
	private final static int XS1B_CHAN_ID_CHANNUM_SHIFT = 0x8;
	private final static int XS1B_CHAN_ID_CHANNUM_SIZE = 0x8;
	private final static int XS1B_CHAN_ID_CHANNUM_MASK = (((1 << XS1B_CHAN_ID_CHANNUM_SIZE) - 1) << XS1B_CHAN_ID_CHANNUM_SHIFT);
		
	private int XS1B_CHAN_ID_CHANNUM(int x){ 
		return (((x) & XS1B_CHAN_ID_CHANNUM_MASK) >> XS1B_CHAN_ID_CHANNUM_SHIFT);
	}
	
	public int getDirection() {
		return direction;
	}
	public void setDirection(int direction) {
		this.direction = direction;
	}
	public Object getConnectedObject() {
		return connectedObject;
	}
	public void setConnectedObject(Object connectedObject) {
		this.connectedObject = connectedObject;
	}
	public int getConnectionStatus() {
		return connectionStatus;
	}
	public void setConnectionStatus(int connectionStatus) {
		this.connectionStatus = connectionStatus;
	}
	
	// resource id
	public void setResourceId(String name){
		this.resourceID = name;
		int resId = Integer.parseInt(resourceID, 16);
		int chanId = XS1B_CHAN_ID_CHANNUM(resId);
		channum = chanId;
	}
	
	public String getName(){
		return resourceID;
	}
	
	public int getChannum(){
		return channum;
	}
	
	public CThread getOwnerThread(){
		return owner;
	}
	
	public XCoreThreadConnection(CThread owner, Object connectedObject,
			int connectionStatus) {
		this.owner = owner;
//		this.direction = direction;
		this.connectedObject = connectedObject;
		this.connectionStatus = connectionStatus;
	}
	
	public boolean equals(Object obj) {
		if (obj instanceof XCoreThreadConnection){
			return ((XCoreThreadConnection)obj).dest.equals(resourceID)
			|| ((XCoreThreadConnection)obj).resourceID.equals(dest);
		}
		return super.equals(obj);
	}
}
